Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.netlib.lapack
Class SLALSA

    java.lang.Object
      org.netlib.lapack.SLALSA

    public class SLALSA

extends java.lang.Object

    SLALSA is a simplified interface to the JLAPACK routine slalsa.
    This interface converts Java-style 2D row-major arrays into
    the 1D column-major linearized arrays expected by the lower
    level JLAPACK routines.  Using this interface also allows you
    to omit offset and leading dimension arguments.  However, because
    of these conversions, these routines will be slower than the low
    level ones.  Following is the description from the original Fortran
    source.  Contact seymour@cs.utk.edu with any questions.

     *     ..
     *
     *  Purpose
     *  =======
     *
     *  SLALSA is an itermediate step in solving the least squares problem
     *  by computing the SVD of the coefficient matrix in compact form (The
     *  singular vectors are computed as products of simple orthorgonal
     *  matrices.).
     *
     *  If ICOMPQ = 0, SLALSA applies the inverse of the left singular vector
     *  matrix of an upper bidiagonal matrix to the right hand side; and if
     *  ICOMPQ = 1, SLALSA applies the right singular vector matrix to the
     *  right hand side. The singular vector matrices were generated in
     *  compact form by SLALSA.
     *
     *  Arguments
     *  =========
     *
     *
     *  ICOMPQ (input) INTEGER
     *         Specifies whether the left or the right singular vector
     *         matrix is involved.
     *         = 0: Left singular vector matrix
     *         = 1: Right singular vector matrix
     *
     *  SMLSIZ (input) INTEGER
     *         The maximum size of the subproblems at the bottom of the
     *         computation tree.
     *
     *  N      (input) INTEGER
     *         The row and column dimensions of the upper bidiagonal matrix.

     *
     *  NRHS   (input) INTEGER
     *         The number of columns of B and BX. NRHS must be at least 1.
     *
     *  B      (input/output) REAL array, dimension ( LDB, NRHS )
     *         On input, B contains the right hand sides of the least
     *         squares problem in rows 1 through M.
     *         On output, B contains the solution X in rows 1 through N.
     *
     *  LDB    (input) INTEGER
     *         The leading dimension of B in the calling subprogram.
     *         LDB must be at least max(1,MAX( M, N ) ).
     *
     *  BX     (output) REAL array, dimension ( LDBX, NRHS )
     *         On exit, the result of applying the left or right singular
     *         vector matrix to B.
     *
     *  LDBX   (input) INTEGER
     *         The leading dimension of BX.
     *
     *  U      (input) REAL array, dimension ( LDU, SMLSIZ ).
     *         On entry, U contains the left singular vector matrices of all

     *         subproblems at the bottom level.
     *
     *  LDU    (input) INTEGER, LDU = > N.
     *         The leading dimension of arrays U, VT, DIFL, DIFR,
     *         POLES, GIVNUM, and Z.
     *
     *  VT     (input) REAL array, dimension ( LDU, SMLSIZ+1 ).
     *         On entry, VT' contains the right singular vector matrices of
     *         all subproblems at the bottom level.
     *
     *  K      (input) INTEGER array, dimension ( N ).
     *
     *  DIFL   (input) REAL array, dimension ( LDU, NLVL ).
     *         where NLVL = INT(log_2 (N/(SMLSIZ+1))) + 1.
     *
     *  DIFR   (input) REAL array, dimension ( LDU, 2 * NLVL ).
     *         On entry, DIFL(*, I) and DIFR(*, 2 * I -1) record
     *         distances between singular values on the I-th level and
     *         singular values on the (I -1)-th level, and DIFR(*, 2 * I)
     *         record the normalizing factors of the right singular vectors
     *         matrices of subproblems on I-th level.
     *
     *  Z      (input) REAL array, dimension ( LDU, NLVL ).
     *         On entry, Z(1, I) contains the components of the deflation-
     *         adjusted updating row vector for subproblems on the I-th
     *         level.
     *
     *  POLES  (input) REAL array, dimension ( LDU, 2 * NLVL ).
     *         On entry, POLES(*, 2 * I -1: 2 * I) contains the new and old
     *         singular values involved in the secular equations on the I-th

     *         level.
     *
     *  GIVPTR (input) INTEGER array, dimension ( N ).
     *         On entry, GIVPTR( I ) records the number of Givens
     *         rotations performed on the I-th problem on the computation
     *         tree.
     *
     *  GIVCOL (input) INTEGER array, dimension ( LDGCOL, 2 * NLVL ).
     *         On entry, for each I, GIVCOL(*, 2 * I - 1: 2 * I) records the

     *         locations of Givens rotations performed on the I-th level on
     *         the computation tree.
     *
     *  LDGCOL (input) INTEGER, LDGCOL = > N.
     *         The leading dimension of arrays GIVCOL and PERM.
     *
     *  PERM   (input) INTEGER array, dimension ( LDGCOL, NLVL ).
     *         On entry, PERM(*, I) records permutations done on the I-th
     *         level of the computation tree.
     *
     *  GIVNUM (input) REAL array, dimension ( LDU, 2 * NLVL ).
     *         On entry, GIVNUM(*, 2 *I -1 : 2 * I) records the C- and S-
     *         values of Givens rotations performed on the I-th level on the

     *         computation tree.
     *
     *  C      (input) REAL array, dimension ( N ).
     *         On entry, if the I-th subproblem is not square,
     *         C( I ) contains the C-value of a Givens rotation related to
     *         the right null space of the I-th subproblem.
     *
     *  S      (input) REAL array, dimension ( N ).
     *         On entry, if the I-th subproblem is not square,
     *         S( I ) contains the S-value of a Givens rotation related to
     *         the right null space of the I-th subproblem.
     *
     *  WORK   (workspace) REAL array.
     *         The dimension must be at least N.
     *
     *  IWORK  (workspace) INTEGER array.
     *         The dimension must be at least 3 * N
     *
     *  INFO   (output) INTEGER
     *          = 0:  successful exit.
     *          < 0:  if INFO = -i, the i-th argument had an illegal value.
     *
     *  Further Details
     *  ===============
     *
     *  Based on contributions by
     *     Ming Gu and Ren-Cang Li, Computer Science Division, University of

     *       California at Berkeley, USA
     *     Osni Marques, LBNL/NERSC, USA
     *
     *  =====================================================================
     *
     *     .. Parameters ..

Constructor Summary
`SLALSA()`

Method Summary
`static void` | `SLALSA(int icompq, int smlsiz, int n, int nrhs, float[][] b, float[][] bx, float[][] u, float[][] vt, int[] k, float[][] difl, float[][] difr, float[][] z, float[][] poles, int[] givptr, int[][] givcol, int[][] perm, float[][] givnum, float[] c, float[] s, float[] work, int[] iwork, intW info)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SLALSA

    public SLALSA()

Method Detail

### SLALSA

    public static void SLALSA(int icompq,
                              int smlsiz,
                              int n,
                              int nrhs,
                              float[][] b,
                              float[][] bx,
                              float[][] u,
                              float[][] vt,
                              int[] k,
                              float[][] difl,
                              float[][] difr,
                              float[][] z,
                              float[][] poles,
                              int[] givptr,
                              int[][] givcol,
                              int[][] perm,
                              float[][] givnum,
                              float[] c,
                              float[] s,
                              float[] work,
                              int[] iwork,
                              intW info)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD